Option Explicit
DefInt A-Z

'----------------------------------------------------------
' BF declares
' This is not yet complete.
'----------------------------------------------------------

' BeautiFont high-level initialization and cleanup calls
Global Const bfSTATE& = 0    ' Use the default font state
Global Const bf24BIT% = 3    ' RGB display mode (no 4 or 8 bit support yet)
Declare Function bfActInit Lib "BFDLL.DLL" (ByVal fmode%) As Integer
Declare Sub bfActEnd Lib "BFDLL.DLL" ()
Global Const bfCLEAR% = 1    ' Clear error
Global Const bfKEEP% = 2     ' Keep error unchanged
Declare Function bfGetError Lib "BFDLL.DLL" (ByVal clearval%) As Integer
Declare Function bfGetErrorString Lib "BFDLL.DLL" (ByVal e%) As String

' Font file functions
Global Const bfBOTH% = 0  ' Allow both RAW and RLE font compressions
Global Const bfRAW% = 1   ' Allow only RAW font data
Global Const bfRLE% = 2   ' Allow only RLE font compressions
Declare Function bfActOpen Lib "BFDLL.DLL" (ByVal fname$) As Long
Declare Function bfActOpenTT Lib "BFDLL.DLL" (ByVal h_dc%, logf As LOGFONT, ByVal chs$, ByVal cmpr%) As Long
Declare Function bfActClose Lib "BFDLL.DLL" (ByVal fnt&) As Integer
Declare Function bfSetFont Lib "BFDLL.DLL" (ByVal state&, ByVal fnt&) As Long
Declare Sub bfActCloseAll Lib "BFDLL.DLL" ()
Declare Function bfSetDirectory Lib "BFDLL.DLL" (ByVal fdir$) As Integer

' Color definitions and the fSetColors() call
Global Const bfWHITE& = &HFFFFFF
Global Const bfBLUE& = &HFF0000
Global Const bfGREEN& = &HFF00&
Global Const bfRED& = &HFF&
Global Const bfCYAN& = &HFFFF00
Global Const bfYELLOW& = &HFFFF&
Global Const bfPURPLE& = &HFF00FF
Global Const bfLIGHTGRAY& = &HC0C0C0
Global Const bfGRAY& = &H808080
Global Const bfDARKGRAY = &H505050
Global Const bfBLACK& = 0
Global Const bfBETA% = 1
Global Const bfGAMMA# = 1#
Declare Function bfSetColors Lib "BFDLL.DLL" (ByVal state&, ByVal f256%, ByVal g256%, ByVal fg&, ByVal bg&, ByVal gradnow%, ByVal beta%, ByVal gamma#) As Long
Declare Function bfSetDropColors Lib "BFDLL.DLL" (ByVal state&, ByVal f256%, ByVal fg&, ByVal bg&, ByVal gradnow%, ByVal beta%, ByVal gamma#) As Long

' Set draw modes
Global Const bfPUT% = 1
Global Const bfTRANS% = 2
Global Const bfBLEND% = 4
Global Const bfIMAGE% = 8
Declare Function bfSetDrawMode Lib "BFDLL.DLL" (ByVal state&, ByVal dmode%, ByVal ratio%) As Long
Declare Function bfSetDropMode Lib "BFDLL.DLL" (ByVal state&, ByVal dmode%, ByVal ratio%) As Long
Global Const bfNORMAL% = 1
Global Const bfUNDER% = 2
Global Const bfDROP% = 8
Global Const bfBACK% = 16
Declare Function bfSetFace Lib "BFDLL.DLL" (ByVal state&, ByVal face%) As Long

' Justification, spacing, sizing and underline functions
Global Const bfHLEFT% = 1
Global Const bfHRIGHT% = 2
Global Const bfHCENTER% = 4
Global Const bfVTOP% = 1
Global Const bfVBOTTOM% = 2
Global Const bfVCENTER% = 4
Global Const bfVBASE% = 8
Declare Function bfSetJust Lib "BFDLL.DLL" (ByVal state&, ByVal hjust%, ByVal vjust%) As Long
Declare Function bfSetSpacing Lib "BFDLL.DLL" (ByVal state&, ByVal spa%) As Long
Declare Function bfSetUnderline Lib "BFDLL.DLL" (ByVal state&, ByVal dist%, ByVal think%) As Long
Declare Function bfGetFontAscent Lib "BFDLL.DLL" (ByVal font&) As Integer
Declare Function bfGetFontDescent Lib "BFDLL.DLL" (ByVal font&) As Integer


' Background functions
Global Const bfBACKSOLID% = 0
Global Const bfBACKBORDER% = 64
Declare Function bfSetBackMode Lib "BFDLL.DLL" (ByVal state&, ByVal mode%, ByVal ratio%) As Long
Declare Function bfSetBackStyle Lib "BFDLL.DLL" (ByVal state&, ByVal style%, ByVal stylesize%) As Long
Declare Function bfSetBackSize Lib "BFDLL.DLL" (ByVal state&, ByVal addedl%, ByVal addedT%, ByVal addedR%, ByVal addedB%) As Long
Declare Sub bfGfxRect Lib "BFDLL.DLL" (ByVal dmode%, ByVal style%, ByVal stylesize%, ByVal color&, ByVal color256%, ByVal x1%, ByVal y1%, ByVal x2%, ByVal y2%)
Declare Sub bfGfxLine Lib "BFDLL.DLL" (ByVal clr&, ByVal c256%, ByVal x1%, ByVal y1%, ByVal x2%, ByVal y2%)

' Text output support functions
Declare Function bfSetBitMap Lib "BFDLL.DLL" (ByVal state&, ByVal hdc&) As Long
Declare Function bfStrDraw Lib "BFDLL.DLL" (ByVal state&, ByVal xpos%, ByVal ypos%, ByVal ftext$) As Long
Declare Function bfChrDraw Lib "BFDLL.DLL" (ByVal state&, ByVal xpos%, ByVal ypos%, ByVal chr1%, ByVal nextchr%) As Long

Sub bfEnd ()

  bfActCloseAll     ' Close all the fonts  ''NOT FOUND. BGR will fix
  bfActEnd          ' Close the DLL usage

End Sub

Function bfInit (ByVal mode%) As Integer

  Dim i%
  Dim j%

  i = bfActInit(mode)              ' Open the DLL for RGB display modes
  j = bfSetDirectory(App.Path)     ' Set a directory to find the fonts

  If i = False Then
    i = MessageBox(BFDEMO.hWnd, "Couldn't fActInit", "ERROR", MB_OK)
    bfInit = False
  Else
    bfInit = True
  End If

End Function

